package co.kr.ajinpaper.salesTask;

import static android.Manifest.permission.POST_NOTIFICATIONS;

import android.app.Activity;
import android.content.Context;
import android.content.pm.PackageManager;
import android.os.Build;

import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import java.util.ArrayList;
import java.util.List;

@RequiresApi(api = Build.VERSION_CODES.TIRAMISU)
public class PermissionManager extends Activity {

    private final Activity activity;
    private final Context context;

    public PermissionManager(Activity activity, Context context) {
        this.activity = activity;
        this.context = context;
    }

    private final String[] permissions = {
            POST_NOTIFICATIONS,
    };

    private List<Object> permissionList;
    private final int MULTIPLE_PERMISSIONS = 1023;

    public boolean checkPermission(){
        int result;
        permissionList = new ArrayList<>();

        for (String pm: permissions){
            result = ContextCompat.checkSelfPermission(context, pm);
            if(result != PackageManager.PERMISSION_GRANTED){
                permissionList.add(pm);
            }
        }

        return permissionList.isEmpty();
    }


    public void requestPermission(){
        ActivityCompat.requestPermissions(activity,
                permissionList.toArray(new String[permissionList.size()]),
                MULTIPLE_PERMISSIONS);
    }

    public boolean permissionResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        if (requestCode == MULTIPLE_PERMISSIONS && (grantResults.length > 0)) {
            for (int i = 0; i < grantResults.length; i++) {
                if (grantResults[i] == -1) {
                    return false;
                }
            }
        }
        return true;
    }

}
