package co.kr.ajinpaper.salesTask;

import static android.content.Context.MODE_PRIVATE;

import android.content.Context;
import android.content.SharedPreferences;
import android.util.Log;
import android.webkit.JavascriptInterface;
import android.webkit.WebView;

public class WebAppInterface {
    private final Context mContext;
    private final MainActivity mActivity;

    public WebAppInterface(MainActivity activity) {
        mContext = activity;
        mActivity = activity;
    }

    @JavascriptInterface
    public String getTitle() {
        SharedPreferences sharedPreferences = mContext.getSharedPreferences("MyApp", MODE_PRIVATE);
        Log.d("WebView", "호출됨: 등록");

        return sharedPreferences.getString("pushTitle", "");
    }

    @JavascriptInterface
    public int deleteTitle() {
        SharedPreferences sharedPreferences = mContext.getSharedPreferences("MyApp", MODE_PRIVATE);
        SharedPreferences.Editor editor = sharedPreferences.edit();
        editor.remove("pushTitle").apply();
        Log.d("WebView", "호출됨: 삭제");
        return 0;
    }

    @JavascriptInterface
    public String setPushToken() {
        // 앱에서 웹에 푸시 토큰 값 보내는 함수
        SharedPreferences sharedPreferences = mContext.getSharedPreferences("FCM", MODE_PRIVATE);
        final String token = sharedPreferences.getString("token", "");
        Log.d("WebView", "발송될 푸시 토큰: " + token);

        return token;
    }

    @JavascriptInterface
    public void getLoginToken(String token) {
        // 웹에서 받은 로그인 토큰을 저장 하는 함수
        Log.d("WebView", "웹에서 받은 로그인 토큰: " + token);
        SharedPreferences sharedPreferences = mContext.getSharedPreferences("login", MODE_PRIVATE);
        SharedPreferences.Editor editor = sharedPreferences.edit();
        editor.putString("token", token);
        editor.apply();
    }

    @JavascriptInterface
    public String setLoginToken() {
        // 저장된 로그인 토큰을 발송 하는 함수
        SharedPreferences sharedPreferences = mContext.getSharedPreferences("login", MODE_PRIVATE);
        final String token = sharedPreferences.getString("token", "");
        Log.d("WebView", "발송될 로그인 토큰: " + token);
        return token;
    }

    @JavascriptInterface
    public void reloadWeb() {
        mActivity.runOnUiThread(() -> {
            // 로그인 후 새로고침하는 함수
            WebView myWebView = mActivity.findViewById(R.id.webView);
            myWebView.reload();
        });
    }

}
